/*
	checks your e-mail out
	Usage: pop3 <pop3 host> <user> <password>
*/

parse arg host user pass .

if host=="" | host=="?" | user=="" | pass=="" then do
	say "Usage: pop3 <pop3 host> <user> <password>"
	exit
end

sock = OpenConnection("tcp","pop3",host)
if sock<0 then do
	say "unable to connect pop3 service at <" || host || ">:" Errno()
	exit
end

say rec()

call sen("USER" user)
call rec()

call sen("PASS" pass)
say rec()

call sen("STAT")
say rec()

call sen("QUIT")
say rec()

exit

sen:
parse arg string
	string=string||d2c(10)
	res = send(sock,string)
	if res ~= length(string) then do
		say "send: error" Errno()
		exit
	end
	return

rec:
	len = recv(sock,"BUF",256)
	if len<0 then do
		say "recv: error" Errno()
		exit
	end
	if left(BUF,4) == "-ERR" then do
		parse var BUF "-ERR" BUF
		say "error from server:" BUF
		exit
	end
	parse var BUF "+OK" BUF
	return translate(BUF,' ',d2c(10))
